/* eslint-disable @typescript-eslint/no-unused-vars */
/*
 * Copyright (c) 2018 THL A29 Limited, a Tencent company. All Rights Reserved.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 */
import * as TencentCloudCommon from "tencentcloud-sdk-nodejs-common"
import {
  RuntimeConfig,
  Label,
  CreateNodePoolResponse,
  CreateNativeNodePoolParam,
  DescribeNodePoolsResponse,
  ExternalNodeInfo,
  DescribeClusterInstancesResponse,
  AutoUpgradeOptions,
  AutoscalingAdded,
  SuperNodePoolInfo,
  NodeCountSummary,
  RegularNodePoolInfo,
  InstanceExtraArgs,
  MachineUpgradeSettings,
  UpdateNativeNodePoolParam,
  InstanceChargePrepaid,
  DeleteNodePoolResponse,
  Tag,
  MachineSetScaling,
  ModifyNodePoolRequest,
  Annotation,
  DescribeClusterInstancesRequest,
  TagSpecification,
  LifecycleConfig,
  ModifyNodePoolResponse,
  Taint,
  Filter,
  ManagementConfig,
  CreateNodePoolRequest,
  NativeNodePoolInfo,
  DescribeNodePoolsRequest,
  NodePool,
  DeleteNodePoolRequest,
  InstanceAdvancedSettings,
  IntOrString,
  ExternalNodePoolInfo,
  Instance,
  NativeNodeInfo,
  InternetAccessible,
  SuperNodeInfo,
  ManuallyAdded,
  RegularNodeInfo,
  SortBy,
  Disk,
  DataDisk,
} from "./tke_models"

/**
 * tke client
 * @class
 */
export class Client extends TencentCloudCommon.AbstractClient {
  constructor(clientConfig: TencentCloudCommon.ClientConfig) {
    super("tke.tencentcloudapi.com", "2022-05-01", clientConfig)
  }

  /**
   * 查询 TKE 节点池列表
   */
  async DescribeNodePools(
    req: DescribeNodePoolsRequest,
    cb?: (error: string, rep: DescribeNodePoolsResponse) => void
  ): Promise<DescribeNodePoolsResponse> {
    return this.request("DescribeNodePools", req, cb)
  }

  /**
   * 创建 TKE 节点池
   */
  async CreateNodePool(
    req: CreateNodePoolRequest,
    cb?: (error: string, rep: CreateNodePoolResponse) => void
  ): Promise<CreateNodePoolResponse> {
    return this.request("CreateNodePool", req, cb)
  }

  /**
   * 删除 TKE 节点池
   */
  async DeleteNodePool(
    req: DeleteNodePoolRequest,
    cb?: (error: string, rep: DeleteNodePoolResponse) => void
  ): Promise<DeleteNodePoolResponse> {
    return this.request("DeleteNodePool", req, cb)
  }

  /**
   * 更新 TKE 节点池
   */
  async ModifyNodePool(
    req: ModifyNodePoolRequest,
    cb?: (error: string, rep: ModifyNodePoolResponse) => void
  ): Promise<ModifyNodePoolResponse> {
    return this.request("ModifyNodePool", req, cb)
  }

  /**
   * 查询集群下节点实例信息
   */
  async DescribeClusterInstances(
    req: DescribeClusterInstancesRequest,
    cb?: (error: string, rep: DescribeClusterInstancesResponse) => void
  ): Promise<DescribeClusterInstancesResponse> {
    return this.request("DescribeClusterInstances", req, cb)
  }
}
